Send patches - preferably formatted by git format-patch - to patches at archlinux32 dot org.
summaryrefslogtreecommitdiff
path: root/src
diff options
context:
space:
mode:
authorLevente Polyak <anthraxx@archlinux.org>2022-12-11 16:16:16 +0100
committerLevente Polyak <anthraxx@archlinux.org>2023-05-19 22:27:13 +0200
commitf834fc4700053cb9a83956c98835b0a158cc054c (patch)
tree31a3e646a262478079c3d03c94683a94d7672ad9 /src
parent8b5bcd01b47845e6459a0ceef2f0eaf898482382 (diff)
db: command for Pacman database modification like update, move etc
Diffstat (limited to 'src')
-rw-r--r--src/lib/db.sh80
-rw-r--r--src/lib/db/move.sh64
-rw-r--r--src/lib/db/remove.sh69
-rw-r--r--src/lib/db/update.sh46
-rw-r--r--src/pkgctl.in9
5 files changed, 268 insertions, 0 deletions
diff --git a/src/lib/db.sh b/src/lib/db.sh
new file mode 100644
index 0000000..397ff0d
--- /dev/null
+++ b/src/lib/db.sh
@@ -0,0 +1,80 @@
+#!/hint/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_DB_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_DB_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+
+set -e
+
+
+pkgctl_db_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [COMMAND] [OPTIONS]
+
+ Pacman database modification for packge update, move etc
+
+ COMMANDS
+ move Move packages between pacman repositories
+ remove Remove packages from pacman repositories
+ update Update the pacman database as final release step
+
+ OPTIONS
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND} move extra-staging extra-testing libfoo libbar
+ $ ${COMMAND} remove core-testing libfoo libbar
+ $ ${COMMAND} update
+_EOF_
+}
+
+pkgctl_db() {
+ if (( $# < 1 )); then
+ pkgctl_db_usage
+ exit 0
+ fi
+
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_db_usage
+ exit 0
+ ;;
+ move)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/db/move.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/db/move.sh
+ pkgctl_db_move "$@"
+ exit 0
+ ;;
+ remove)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/db/remove.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/db/remove.sh
+ pkgctl_db_remove "$@"
+ exit 0
+ ;;
+ update)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/db/update.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/db/update.sh
+ pkgctl_db_update "$@"
+ exit 0
+ ;;
+ -*)
+ die "invalid argument: %s" "$1"
+ ;;
+ *)
+ die "invalid command: %s" "$1"
+ ;;
+ esac
+ done
+}
diff --git a/src/lib/db/move.sh b/src/lib/db/move.sh
new file mode 100644
index 0000000..825b350
--- /dev/null
+++ b/src/lib/db/move.sh
@@ -0,0 +1,64 @@
+#!/hint/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_DB_MOVE_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_DB_MOVE_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+# shellcheck source=src/lib/common.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+
+set -e
+
+
+pkgctl_db_move_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS] [SOURCE_REPO] [TARGET_REPO] [PKGBASE]...
+
+ Move packages between binary repositories.
+
+ OPTIONS
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND} extra-staging extra-testing libfoo libbar
+ $ ${COMMAND} extra core libfoo libbar
+_EOF_
+}
+
+pkgctl_db_move() {
+ local SOURCE_REPO=""
+ local TARGET_REPO=""
+ local PKGBASES=()
+
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_db_move_usage
+ exit 0
+ ;;
+ -*)
+ die "invalid argument: %s" "$1"
+ ;;
+ *)
+ break
+ ;;
+ esac
+ done
+
+ if (( $# < 3 )); then
+ pkgctl_db_move_usage
+ exit 1
+ fi
+
+ SOURCE_REPO=$1
+ TARGET_REPO=$2
+ shift 2
+ PKGBASES+=("$@")
+
+ # shellcheck disable=SC2029
+ ssh "${PACKAGING_REPO_RELEASE_HOST}" db-move "${SOURCE_REPO}" "${TARGET_REPO}" "${PKGBASES[@]}"
+}
diff --git a/src/lib/db/remove.sh b/src/lib/db/remove.sh
new file mode 100644
index 0000000..ba21c83
--- /dev/null
+++ b/src/lib/db/remove.sh
@@ -0,0 +1,69 @@
+#!/hint/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_DB_REMOVE_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_DB_REMOVE_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+# shellcheck source=src/lib/common.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+
+set -e
+
+
+pkgctl_db_remove_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS] [REPO] [PKGBASE]...
+
+ Remove packages from binary repositories.
+
+ OPTIONS
+ -a, --arch Override the architecture (disables auto-detection)
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND} core-testing libfoo libbar
+ $ ${COMMAND} --arch x86_64 core libyay
+_EOF_
+}
+
+pkgctl_db_remove() {
+ local REPO=""
+ local ARCH=any
+ local PKGBASES=()
+
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_db_remove_usage
+ exit 0
+ ;;
+ -a|--arch)
+ (( $# <= 1 )) && die "missing argument for %s" "$1"
+ ARCH=$2
+ shift 2
+ ;;
+ -*)
+ die "invalid argument: %s" "$1"
+ ;;
+ *)
+ break
+ ;;
+ esac
+ done
+
+ if (( $# < 2 )); then
+ pkgctl_db_remove_usage
+ exit 1
+ fi
+
+ REPO=$1
+ shift
+ PKGBASES+=("$@")
+
+ # shellcheck disable=SC2029
+ ssh "${PACKAGING_REPO_RELEASE_HOST}" db-remove "${REPO}" "${ARCH}" "${PKGBASES[@]}"
+}
diff --git a/src/lib/db/update.sh b/src/lib/db/update.sh
new file mode 100644
index 0000000..269720d
--- /dev/null
+++ b/src/lib/db/update.sh
@@ -0,0 +1,46 @@
+#!/hint/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_DB_UPDATE_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_DB_UPDATE_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+# shellcheck source=src/lib/common.sh
+source "${_DEVTOOLS_LIBRARY_DIR}"/lib/common.sh
+
+set -e
+
+
+pkgctl_db_update_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [OPTIONS]
+
+ Update the binary repository as final release step for packages that
+ have been transfered and staged on ${PACKAGING_REPO_RELEASE_HOST}.
+
+ OPTIONS
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND}
+_EOF_
+}
+
+pkgctl_db_update() {
+ # option checking
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_db_update_usage
+ exit 0
+ ;;
+ *)
+ die "invalid argument: %s" "$1"
+ ;;
+ esac
+ done
+
+ ssh "${PACKAGING_REPO_RELEASE_HOST}" db-update
+}
diff --git a/src/pkgctl.in b/src/pkgctl.in
index e024d1f..d9e1b4c 100644
--- a/src/pkgctl.in
+++ b/src/pkgctl.in
@@ -20,6 +20,7 @@ usage() {
COMMANDS
auth Authenticate with services like GitLab
+ db Pacman database modification for packge update, move etc
diff Compare package files using different modes
repo Manage Git packaging repositories and their configuration
@@ -60,6 +61,14 @@ while (( $# )); do
pkgctl_auth "$@"
exit 0
;;
+ db)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/auth.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/db.sh
+ pkgctl_db "$@"
+ exit 0
+ ;;
diff)
_DEVTOOLS_COMMAND+=" $1"
shift